%define name ghc
%define version 5.02.2
%define release 2mdk

Summary: Glasgow Haskell Compiler
Name: %{name}
Version: %{version}
Release: %{release}
URL: http://haskell.org/ghc/
Source0: http://www.haskell.org/ghc/dist/5.02.2/ghc-5.02.2-src-1.tar.bz2
Patch0: ghc-configure.in.patch.bz2
License: MIT
Group: Development/Other
BuildRoot: %{_tmppath}/%{name}-buildroot
Prefix: %{_prefix}
Requires: gmp-devel
Provides: haskell
ExclusiveArch: %ix86
BuildRequires: happy >= 1.9, ghc

%package prof
Summary: Profiling libraries for GHC
Group: Development/Other
Requires: %{name} = %{version}

%description
The Glorious Glasgow Haskell Compilation System (GHC) is a robust,
fully-featured, optimising compiler for the functional programming
language Haskell 98.  GHC compiles Haskell to either native code or
C. It implements numerous experimental language extensions to Haskell,
including concurrency, a foreign language interface, several
type-system extensions, exceptions, and so on. GHC comes with a
generational garbage collector, a space and time profiler, and a
comprehensive set of libraries.

Haskell 98 is "the" standard lazy functional programming language.
More info plus the language definition is at http://www.haskell.org/.

%description prof
Profiling libraries for Glorious Glasgow Haskell Compilation System (GHC).
They should be installed when GHC's profiling subsystem is needed.

%prep
%setup -q

## alpha suck ##
%ifarch alpha
%patch0 -p1
%endif

cat >mk/build.mk <<END
GhcLibWays = p
SRC_HAPPY_OPTS += -agc # useful from Happy 1.7 onwards
GhcWithInterpreter=YES
END

%build
# run autoconf if necessary
#
[ -x configure ] || autoconf

%configure
make boot
#make -C glafp-utils sgmlverb
make all
#make -C docs ps html
#make -C ghc/docs ps html

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT%{_bindir}
make prefix=$RPM_BUILD_ROOT%{prefix} bindir=$RPM_BUILD_ROOT%{_bindir} libdir=$RPM_BUILD_ROOT%{_libdir}/%{name}-%{version} install

   cat > ghc.list <<EOF
%defattr(-,root,root)
%doc ghc/ANNOUNCE ghc/README 
#%doc ghc/docs/users_guide/users_guide
%{_bindir}/*
EOF

   cat > ghc-prof.list <<EOF
%defattr(-,root,root)
EOF

(cd $RPM_BUILD_ROOT ; find usr/lib/ghc* -name "*.p_hi" -or -name "libHS*_p.a" -printf "/%%p\n") >> ghc-prof.list

(cd $RPM_BUILD_ROOT ; find usr/lib/ghc* ! -type d -printf "/%%p\n") >> ghc.list
(cd $RPM_BUILD_ROOT ; find usr/lib/ghc*   -type d -printf "%%%%dir /%%p\n") >> ghc.list
perl -ni -e 'BEGIN { open F, "ghc-prof.list"; /^%/ or $s{$_} = 1 foreach <F>; } print unless $s{$_}' ghc.list

%clean
rm -rf $RPM_BUILD_ROOT

%files -f ghc.list

%files prof -f ghc-prof.list

%changelog
* Sat Jan 26 2002 Pixel <pixel@mandrakesoft.com> 5.02.2-2mdk
- rebuild (ghci needs two stage build)

* Sun Jan 13 2002 Pixel <pixel@mandrakesoft.com> 5.02.2-1mdk
- new version

* Mon Nov  5 2001 Pixel <pixel@mandrakesoft.com> 5.02.1-1mdk
- new version

* Wed Sep 26 2001 Pixel <pixel@mandrakesoft.com> 5.02-2mdk
- rebuilding to enable ghci (why didn't it make through the first time?)

* Wed Sep 26 2001 Pixel <pixel@mandrakesoft.com> 5.02-1mdk
- new version

* Fri Aug 24 2001 Pixel <pixel@mandrakesoft.com> 5.00.2-2mdk
- fix ghci: don't use libm (?)

* Mon Jun 18 2001 Pixel <pixel@mandrakesoft.com> 5.00.2-1mdk
- new version (bug fix version)

* Fri May 25 2001 Pixel <pixel@mandrakesoft.com> 5.00.1-1mdk
- new version (bug fix version)

* Fri Apr 27 2001 Pixel <pixel@mandrakesoft.com> 5.00-1mdk
- new version

* Tue Dec 26 2000 Pixel <pixel@mandrakesoft.com> 4.08.1-3mdk
- rebuild, fix for gcc-2.96, ...

* Mon Oct  2 2000 Pixel <pixel@mandrakesoft.com> 4.08.1-2mdk
- remove the buildreq stylesheets

* Wed Sep  6 2000 Pixel <pixel@mandrakesoft.com> 4.08.1-1mdk
- new version

* Mon Aug  7 2000 Pixel <pixel@mandrakesoft.com> 4.08-1mdk
- new version

* Fri Jul 07 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 4.06-5mdk
- ExcludeArch: ppc too.

* Wed May 24 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 4.06-4mdk
- ExcludeArch: alpha. (ghc need happy which is not compile on alpha-linux).

* Sun Apr 09 2000 Geoffrey Lee <snailtalk@linux-mandrake.com>
- alpha suck fix

* Fri Mar 31 2000 Pixel <pixel@mandrakesoft.com> 4.06-2mdk
- add doc

* Mon Feb  7 2000 Pixel <pixel@mandrakesoft.com> 4.06-1mdk
- initial spec


# end of file
